'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = subpathReducer;

var _mindfrontReduxUtils = require('mindfront-redux-utils');

var _lodash = require('lodash.mapvalues');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function subpathReducer(subpath, initialState) {
  if (typeof subpath !== 'function') {
    (function () {
      var fixedSubpath = subpath;
      subpath = function subpath() {
        return fixedSubpath;
      };
    })();
  }
  return function (reducer) {
    var actionHandlers = reducer.actionHandlers;

    if (actionHandlers instanceof Object) {
      var _ret2 = function () {
        var initialSubState = reducer.initialState;
        return {
          v: (0, _mindfrontReduxUtils.createReducer)(initialState, (0, _lodash2.default)(actionHandlers, function (reducer) {
            return function (state, action) {
              return state.updateIn(subpath(action), function () {
                var substate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialSubState;
                return reducer(substate, action);
              });
            };
          }))
        };
      }();

      if ((typeof _ret2 === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret2)) === "object") return _ret2.v;
    }
    return function () {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments[1];
      return state.updateIn(subpath(action), function (substate) {
        return reducer(substate, action);
      });
    };
  };
}